/*
    `yy' - A lightshow-like program that graphically represents sound.
    Copyright (C) 1998  Nikos Gorogiannis <kgor@softlab.ece.ntua.gr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
    See file `copyright' for details.
*/

#ifndef COLOR_MIX_HH
#define COLOR_MIX_HH

#include "def_shared.hh"

#define COLOR_MIXERS 3

inline Pixel colorMixer(const Pixel new_color, const Pixel old_color)
{
	switch(sharedVars->colorMixerIndex)
	{
		case 1:
			if(brightness(new_color) > brightness(old_color))
				return new_color;
			else
				return old_color;
		case 2:
			if(palette(new_color) == palette(old_color))
			{
				int br1 = brightness(new_color) + 
					brightness(old_color);
				if(br1>MAX_BRIGHT)
					br1 = MAX_BRIGHT;
				return pcolor(palette(new_color), br1);
			}
		default:
		case 0:
			if(brightness(new_color)==0)
				return old_color;
			else
				return new_color;
	}
}
#endif
