/*
    `yy' - A lightshow-like program that graphically represents sound.
    Copyright (C) 1998  Nikos Gorogiannis <kgor@softlab.ece.ntua.gr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
    See file `copyright' for details.
*/

#ifndef DEF_SETTINGS_HH
#define DEF_SETTINGS_HH

#include <stdio.h>
#include <unistd.h>

// sample types:
// S = Signed, U = Unsigned
// 16 = 16 bits (short), 8 = 8 bits (char)
#define S16 0
#define U16 1 // doesn't work on by SB16
#define S8  2 // doesn't work on by SB16
#define U8  3 // be sure to adjust `aperture'!

// select whichever sample type works on your soundcard. S16 is the preferred
#define SAMPLE_TYPE S16

// log2 of samples/channel
#define LOG_SAMPLES 8

// samples/channel
#define SAMPLES (1 << LOG_SAMPLES)

// sample format
#if SAMPLE_TYPE == S16
typedef signed short Sample;
#elif SAMPLE_TYPE == U16
typedef unsigned short Sample;
#elif SAMPLE_TYPE == S8
typedef signed char Sample;
#elif SAMPLE_TYPE == U8
typedef unsigned char Sample;
#endif


// buffer size in chars
#define BUF_SIZE ((ssize_t) (sizeof(Sample)*SAMPLES*2))

// sampling frequency sent to sound card;
#define FREQUENCY 44100

extern volatile Sample * buffer;

#endif
