/*
    `yy' - A lightshow-like program that graphically represents sound.
    Copyright (C) 1998  Nikos Gorogiannis <kgor@softlab.ece.ntua.gr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
    See file `copyright' for details.
*/

#ifndef FRAMEBUFFER_HH
#define FRAMEBUFFER_HH


#include <vgagl.h>

#include "def_shared.hh"
#include "icons.hh"

class FrameBuffer
{
public:
	void create(void);
	void destroy(void);

	void setcolor(int c, int r, int g, int b) const;

	void copyToScreen(void) const;
	
	void age(const double aging) const;
	
	void icon(const int x, const int y, const int index,
		const Pixel c, const Pixel p) const;

	int width;
	int height;

private:
	Icons icons;
	GraphicsContext *screen;
	int screenSize;
};

#endif
