/*
    `yy' - A lightshow-like program that graphically represents sound.
    Copyright (C) 1998  Nikos Gorogiannis <kgor@softlab.ece.ntua.gr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
    See file `copyright' for details.
*/

#include <stdio.h>
#include "def_shared.hh"
#include "function.hh"

IntFunction::IntFunction(double (*f)(double), double A, double B, unsigned N)
{	
	n = N;
	a = A;
	b = B;
	intTable = new double[n];
	chkVal(intTable, NULL);
	difTable = new double[n-1];
	chkVal(difTable, NULL);
	step = (b-a)/(n-1);
	
	double x = a;
	intTable[0] = f(a);
	x += step;
	
	for(register unsigned i=1; i<n; i++, x+=step)
	  {
		  intTable[i] = f(x);
		  difTable[i-1] = intTable[i] - intTable[i-1];
	  }
}


IntFunction::~IntFunction(void)
{
	delete [] intTable;
	delete [] difTable;
}
