/*
    `yy' - A lightshow-like program that graphically represents sound.
    Copyright (C) 1998  Nikos Gorogiannis <kgor@softlab.ece.ntua.gr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
    See file `copyright' for details.
*/

#ifndef FUNCTION_HH
#define FUNCTION_HH

// interpolated function
class IntFunction
{
public:
	IntFunction(double (*f)(double), double A, double B, unsigned N);
	inline double operator() (const double x) const;
	~IntFunction(void);
	
private:
	double *intTable, *difTable, a, b, step;
	unsigned n;
};

inline double IntFunction::operator() (const double x) const
{
	if(x<=a)
	    return intTable[0];

	if(x>=b)
	    return intTable[n-1];
 
	const double xi = (x-a)/step;
	register const unsigned i = (unsigned) xi;

	return difTable[i]*(xi - (double)i) + intTable[i];
}

#endif
