/*
    `yy' - A lightshow-like program that graphically represents sound.
    Copyright (C) 1998  Nikos Gorogiannis <kgor@softlab.ece.ntua.gr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
    See file `copyright' for details.
*/

// file creates an array of pointers to character arrays. These contain
// odd-sized bitmaps of spheres. All these are contain in a class.

#include <iostream.h>
#include <math.h>
#include "icons.hh"

Icons::Icons(void)
{
	for(int i=0; i<ICONS; i++)
		bitmap[i] = create_icon(i);
}

Icons::~Icons()
{
	for(int i=0; i<=ICONS; i+=2)
		delete [] bitmap[i];
}

int * Icons::create_icon(int center)
{
	int size = 2*center+1;
	int * icon = new int [size*size];
	double maxval = sqrt(center*center);
	int value;
	
	for(int x=0; x<=center; x++)
		for(int y=0; y<=x; y++)
		{
			double r = sqrt(x*x + y*y);
			if(r>maxval)
				value = 0;
			else
				value = (int)
					(MAX_DIVISOR*(maxval - r)/maxval);
					
			icon[ (center + y)*size + center + x ] = value;
			icon[ (center + x)*size + center + y ] = value;
			icon[ (center - y)*size + center - x ] = value;
			icon[ (center - x)*size + center - y ] = value;
			icon[ (center - y)*size + center + x ] = value;
			icon[ (center - x)*size + center + y ] = value;
			icon[ (center + y)*size + center - x ] = value;
			icon[ (center + x)*size + center - y ] = value;
		}
		
	return icon;
}

/*
void Icons::print_icon(int size)
{
	int half = half_odd(size);
	
	for(int y=0; y<size; y++)
	{
		for(int x=0; x<size; x++)
			cout << (int) *(bitmap[ half ] + (y*size+x)) << ' ';
		cout << '\n';
	}
	cout << '\n';	
}
*/
	