%{
/*#include <iostream.h>*/
#include <stdlib.h>
#include "parser.h"
#include "def_shared.hh"

unsigned lineCount = 1;
%}
	
cr \n
white [ \t]
letter [a-zA-Z]
digit [0-9]

%%

{cr}                { lineCount++; }
"#"(.+){cr}         { lineCount++; /* ignore comments */}
{white}+            { /* do nothing */}

{digit}+            { yylval.UnsignedVal = (unsigned) strtoul(yytext, NULL, 10); return TK_UNSIGNED; }
{digit}+"."{digit}+ { yylval.DoubleVal = strtod(yytext, NULL); return TK_DOUBLE; }

"<"                 { return '<'; }
">"                 { return '>'; }
"="                 { return '='; }
"%"                 { return '%'; }
","                 { return ','; }
"waitkey"           { return TK_WAITKEY; }
"bpm"               { return TK_BPM; }
"beatsPerBar"       { return TK_BPB; }
"in"                { return TK_IN; }
"attenuation"       { return TK_ATTENUATION; }
"threshold"         { return TK_THRESHOLD; }
"aging"             { return TK_AGING; }
"sleep"             { return TK_SLEEP; }
"transformation"    { return TK_TRANSFORMATION; }
"color"             { return TK_COLOR; }
"aperture"          { return TK_APERTURE; }
"color_mixer"       { return TK_COLOR_MIXER; }
"iconMinSize"       { return TK_ICONMINSIZE; }
"iconMaxSize"       { return TK_ICONMAXSIZE; }

.                   { error("Lexical error at line:" << lineCount); }


%%
/*
int main()
{
        int token;
	
	while((token=yylex())!=0)
	{
	        cerr << "\nToken " << token << " found at line " << lineCount;
	}
        
	return 0;
}
*/
