#include "def_shared.hh"
#include <sys/ipc.h>
#include <sys/sem.h>

class Semaphore
{
public:
	inline void create(void);
	inline void signal(void) const;
	inline void wait(void) const;
	inline void destroy(void);
	int semid;
};

inline void Semaphore::create(void)
{
	semid = semget(IPC_PRIVATE, 1, IPC_CREAT | IPC_EXCL | 066);
	chkVal(semid, -1);
	
	union semun arg;
	arg.val = 1;
	semctl(semid, 0, SETVAL, arg);
}

inline void Semaphore::signal(void) const
{
	struct sembuf semops = {0, 1, 0};
	
	chk(semop(semid, &semops, 1));
}

inline void Semaphore::wait(void) const
{
	struct sembuf semops = {0, -1, 0};
	
	chk(semop(semid, &semops, 1));
}

inline void Semaphore::destroy(void)
{
	union semun arg;

	chk(semctl(semid, 0, IPC_RMID, arg));
}

