/*
    `yy' - A lightshow-like program that graphically represents sound.
    Copyright (C) 1998  Nikos Gorogiannis <kgor@softlab.ece.ntua.gr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
    See file `copyright' for details.
*/

#ifndef TRANS_HH
#define TRANS_HH

#define TRANSFORMATIONS 11

#define MAXX 1000
#define MAXY 1000

typedef struct
{
	unsigned freqIndex;
	double phi;
	double measMean;
	double phaseDiff;
} TransInput;

typedef unsigned (*CoordFunc)(const TransInput * ti);

typedef struct
{
	CoordFunc xFunc;
	CoordFunc yFunc;
} Transformation;

extern const Transformation transformations[TRANSFORMATIONS];

extern void initTransformations(void);

#endif
